--Author Manaleaf - Sargeras
--History Replay Calcs for Leaflet


function LFLT_A.Replay()

	--Compares heal totals using a different set of stats which generated the heal.
	function LFLT_T.healCompare(heal, spellName, spellType, replayStats, recordStats, hCount)
		--Spell CoEff.
		local sce
		--Leech NYI
		--Hots or Efflo
		if spellType == "SPELL_PERIODIC_HEAL"
			or (spellName == LFLT_T.spells.efflorescence) then
			sce = heal / 	( recordStats.int 
							* (1 + (recordStats.mst - 1) * hCount)
							* (recordStats.crt * recordStats.critBonusOutput)
							* recordStats.vrs
							* recordStats.hst)
			
			return 	(sce * replayStats.int 
						* (1 + (replayStats.mst - 1) * hCount) 
						* (replayStats.crt * replayStats.critBonusOutput)
						* replayStats.vrs
						* replayStats.hst)
		
		--Direct Heals
		elseif spellType == "SPELL_HEAL" then
			sce = heal / 	( recordStats.int 
							* (1 + (recordStats.mst - 1) * hCount)
							* (recordStats.crt * replayStats.critBonusOutput)
							* recordStats.vrs)
			
			return  (sce * replayStats.int 
						* (1 + (replayStats.mst - 1) * hCount) 
						* (recordStats.crt * replayStats.critBonusOutput)
						* replayStats.vrs)
		end
		
		
	end

		--Backup Display Data
	local function backUpDisplayData()
		LFLT_T.backup.cur_int_hpc = LFLT_T.score.cur_int_hpc
		LFLT_T.backup.cur_int_hpt = LFLT_T.score.cur_int_hpt
		LFLT_T.backup.cur_mst_hpc = LFLT_T.score.cur_mst_hpc
		LFLT_T.backup.cur_mst_hpt = LFLT_T.score.cur_mst_hpt
		LFLT_T.backup.cur_hst_hpc = LFLT_T.score.cur_hst_hpc
		LFLT_T.backup.cur_hst_hpt = LFLT_T.score.cur_hst_hpt
		LFLT_T.backup.cur_crt_hpc = LFLT_T.score.cur_crt_hpc
		LFLT_T.backup.cur_crt_hpt = LFLT_T.score.cur_crt_hpt
		LFLT_T.backup.cur_vrs_hpc = LFLT_T.score.cur_vrs_hpc
		LFLT_T.backup.cur_vrs_hpt = LFLT_T.score.cur_vrs_hpt
		LFLT_T.backup.cur_lch_hpc = LFLT_T.score.cur_lch_hpc
		LFLT_T.backup.cur_lch_hpt = LFLT_T.score.cur_lch_hpt
		LFLT_T.backup.ttl_int_hpc = LFLT_T.score.ttl_int_hpc
		LFLT_T.backup.ttl_int_hpt = LFLT_T.score.ttl_int_hpt
		LFLT_T.backup.ttl_mst_hpc = LFLT_T.score.ttl_mst_hpc
		LFLT_T.backup.ttl_mst_hpt = LFLT_T.score.ttl_mst_hpt
		LFLT_T.backup.ttl_hst_hpc = LFLT_T.score.ttl_hst_hpc
		LFLT_T.backup.ttl_hst_hpt = LFLT_T.score.ttl_hst_hpt
		LFLT_T.backup.ttl_crt_hpc = LFLT_T.score.ttl_crt_hpc
		LFLT_T.backup.ttl_crt_hpt = LFLT_T.score.ttl_crt_hpt
		LFLT_T.backup.ttl_vrs_hpc = LFLT_T.score.ttl_vrs_hpc
		LFLT_T.backup.ttl_vrs_hpt = LFLT_T.score.ttl_vrs_hpt
		LFLT_T.backup.ttl_lch_hpc = LFLT_T.score.ttl_lch_hpc
		LFLT_T.backup.ttl_lch_hpt = LFLT_T.score.ttl_lch_hpt
	end
	
	--Restore Display Data from Backup
	local function retrieveDisplayDataBackup()
		LFLT_T.score.cur_int_hpc = LFLT_T.backup.cur_int_hpc 
		LFLT_T.score.cur_int_hpt = LFLT_T.backup.cur_int_hpt 
		LFLT_T.score.cur_mst_hpc = LFLT_T.backup.cur_mst_hpc 
		LFLT_T.score.cur_mst_hpt = LFLT_T.backup.cur_mst_hpt 
		LFLT_T.score.cur_hst_hpc = LFLT_T.backup.cur_hst_hpc 
		LFLT_T.score.cur_hst_hpt = LFLT_T.backup.cur_hst_hpt 
		LFLT_T.score.cur_crt_hpc = LFLT_T.backup.cur_crt_hpc 
		LFLT_T.score.cur_crt_hpt = LFLT_T.backup.cur_crt_hpt 
		LFLT_T.score.cur_vrs_hpc = LFLT_T.backup.cur_vrs_hpc 
		LFLT_T.score.cur_vrs_hpt = LFLT_T.backup.cur_vrs_hpt 
		LFLT_T.score.cur_lch_hpc = LFLT_T.backup.cur_lch_hpc 
		LFLT_T.score.cur_lch_hpt = LFLT_T.backup.cur_lch_hpt 
		LFLT_T.score.ttl_int_hpc = LFLT_T.backup.ttl_int_hpc 
		LFLT_T.score.ttl_int_hpt = LFLT_T.backup.ttl_int_hpt 
		LFLT_T.score.ttl_mst_hpc = LFLT_T.backup.ttl_mst_hpc 
		LFLT_T.score.ttl_mst_hpt = LFLT_T.backup.ttl_mst_hpt 
		LFLT_T.score.ttl_hst_hpc = LFLT_T.backup.ttl_hst_hpc 
		LFLT_T.score.ttl_hst_hpt = LFLT_T.backup.ttl_hst_hpt 
		LFLT_T.score.ttl_crt_hpc = LFLT_T.backup.ttl_crt_hpc 
		LFLT_T.score.ttl_crt_hpt = LFLT_T.backup.ttl_crt_hpt 
		LFLT_T.score.ttl_vrs_hpc = LFLT_T.backup.ttl_vrs_hpc 
		LFLT_T.score.ttl_vrs_hpt = LFLT_T.backup.ttl_vrs_hpt 
		LFLT_T.score.ttl_lch_hpc = LFLT_T.backup.ttl_lch_hpc 
		LFLT_T.score.ttl_lch_hpt = LFLT_T.backup.ttl_lch_hpt 
	end
	
	function LFLT_T.abortReplay(call)
		local message, displayMessage = "", ""
		if call == 1 then
			message = "Leaflet: Cannot run replays during an Active Session. (ie: Boss Encounter or 5 man Dungeon)"
			displayMessage = "Cannot run replays\nduring an\nActive Session."
		elseif call == 2 then
			message = "Leaflet: Replay Aborted, Session Started During Replay"
			displayMessage = "Replay Aborted:\nSession Started\nDuring Replay."
		else 
			message = "Replay Aborted"
		end
		print(message)
		_G[LFLT_F.replayResultPercentFrameTextObj.name]:SetText(displayMessage)
		retrieveDisplayDataBackup()
		LFLT_T.manualOverride.updateDisplay = false
		LFLT_T.updateDisplay(2)
		return
	end

		--[[Table Directory Translations
	----Targets marked with '*'
	Targets: healValue, hCount, spellName
	Origin:
		LFLT = {
				history = {
							records = {
										spells = {heal = healvalue}
							}
				}
		}
		LFLT.history[historyEntryNum].records[recNum].spells[sName].heal[hCount] = healValue
		--records in history are copies of session's LFLT.sessionRecords (copied in saveSession)
			LFLT.history[historyEntryNum].records[recNum] = LFLT.sessionRecords[recNum]
	Final:
		healData.heal[hCount] = healValue
	Translations:
		entry = LFLT.history[historyEntryNum]
		record = entry.records[recNum]
		healData = record.spells[spellName]
		healData[*spellName].heal[*hCount] = *healValue
	]]
	function LFLT_T.replay()
		local entryList = LFLT_T.getSelectedHistoryButtons()
		if #entryList > 0 then
			--Check for Interrupt due to session start
			if LFLT.session ~= "none" then LFLT_T.abortReplay(2); return end
			LFLT_T.manualOverride.updateDisplay = true
			backUpDisplayData()
			LFLT.clearAllStats()
			
			local adjHeal
			local adjHealSum 			= 0 
			local recHealSum 	 		= 0 	
			
			local cur_int_hpc, cur_mst_hpc, cur_hst_hpc, cur_crt_hpc, cur_vrs_hpc
			local cur_hst_hpt, cur_hst_com, ttl_hst_com
			local maxCurHeal, selectedCurMax
			--local cur_lch_hpc
					
			local statWeights 	= {int = {}, mst = {}, hst_hpc = {}, hst_hpt = {}, hst_com = {}, crt = {}, vrs = {}} 
			local statWeightAverages 	= {}
			local healPercChange 		= {}
			local healPercChangeAverage 
			local replayStats			= {}
					
			--Stats from gear player is currently wearing
			local int,mst,hst,crt,vrs,lch,hstMod,critBonusOutput = LFLT_T.getStats()
			for _,entry in ipairs(entryList) do				--A History Entry
				for _, record in ipairs(entry.records) do	--A Record in the History Entry
					--Check for Interrupt due to session start 
					if LFLT.session ~= "none" then LFLT_T.abortReplay(1); return end
					
					replayStats = {
						["int"] = int + (record.int - entry.int), 
						["mst"] = mst + (record.mst - entry.mst), 
						["hst"] = hst + (record.hst - entry.hst), 
						["crt"] = crt + (record.crt - entry.crt), 
						["vrs"] = vrs + (record.vrs - entry.vrs), 
						["hstMod"] = hstMod + (record.hstMod - entry.hstMod),
						["critBonusOutput"] = LFLT_T.critBonusOutput + (record.critBonusOutput - entry.critBonusOutput),
					} 
					--Calcs for spells in records
					
					--Overrides 
					---getUnit will always return player as unit
					--disables recordInsert
					LFLT_T.manualOverride.getUnit 	= "player"
					LFLT_T.manualOverride.recordInsert = true
					for spellName,healData in pairs(record.spells) do
						for hCount, heal in pairs(healData.heal) do	
							adjHeal = LFLT_T.healCompare(heal, spellName, healData.sType, replayStats, record, hCount)
							adjHealSum 	= adjHealSum + adjHeal
							recHealSum 	= recHealSum + heal
							LFLT_T.manualOverride.hotCounter = hCount
							--Manual Entries for statCalc
							LFLT_T.statCalc(replayStats, nil, healData.sType, nil, UnitGUID("player"), nil, 
									 nil, nil, nil, nil, nil, 
									 nil, nil, spellName, nil, adjHeal, 
									 0, nil, false)

							LFLT_T.leechHaste = {}
						end
					end
				end
				
				--Deactivate Manual Overrides
				LFLT_T.manualOverride.hotCounter = nil
				LFLT_T.manualOverride.getUnit	= nil
				LFLT_T.manualOverride.recordInsert = nil
				tinsert(healPercChange, adjHealSum / recHealSum)
				adjHealSum 			= 0	
				recHealSum 			= 0 	
								
				local maxCurHeal, selectedCurMax = LFLT.maxButNotZero(0.001,	LFLT_T.score.cur_int_hpc, LFLT_T.score.cur_mst_hpc, 
																		LFLT_T.score.cur_hst_hpc, LFLT_T.score.cur_crt_hpc, 
																		LFLT_T.score.cur_vrs_hpc) 

				--HPC:Current Encounter Healing Score Allocation
				cur_int_hpc = LFLT_T.score.cur_int_hpc / maxCurHeal
				cur_mst_hpc = LFLT_T.score.cur_mst_hpc / maxCurHeal
				cur_hst_hpc = LFLT_T.score.cur_hst_hpc / maxCurHeal
				cur_crt_hpc = LFLT_T.score.cur_crt_hpc / maxCurHeal
				cur_vrs_hpc = LFLT_T.score.cur_vrs_hpc / maxCurHeal
				--cur_lch_hpc = LFLT_T.score.cur_lch_hpc / maxCurHeal
				
				maxCurHeal,_ = select(selectedCurMax, 0.001, 	LFLT_T.score.cur_int_hpt, LFLT_T.score.cur_mst_hpt, LFLT_T.score.cur_hst_hpt, 
																LFLT_T.score.cur_crt_hpt, LFLT_T.score.cur_vrs_hpt) 

				--HPCT:Current Encounter Healing Score Allocation
				cur_hst_hpt = LFLT_T.score.cur_hst_hpt / maxCurHeal
				--Composite Haaste
				cur_hst_com = cur_hst_hpc * (1 - LFLT.hasteCompositeRatio) + cur_hst_hpt * LFLT.hasteCompositeRatio
				
				tinsert(statWeights.int, cur_int_hpc)
				tinsert(statWeights.mst, cur_mst_hpc)
				tinsert(statWeights.hst_hpc, cur_hst_hpc)
				tinsert(statWeights.hst_hpt, cur_hst_hpt)
				tinsert(statWeights.hst_com, cur_hst_com)
				tinsert(statWeights.crt, cur_crt_hpc)
				tinsert(statWeights.vrs, cur_vrs_hpc)
			end

			--Final Averages
			for k,v in pairs(statWeights) do
				statWeightAverages[k] = LFLT_T.getTableAverage(v)
			end
			healPercChangeAverage = LFLT_T.getTableAverage(healPercChange)
			healPercChangeAverage = LFLT_T.roundToDecimal((healPercChangeAverage - 1 ) * 100, 1)
			local statFormat = "\n%12s: "
			local dataFormat = "\n%-5." .. tostring(LFLT.option.displayPrecision) .. "f"
			local outString1, outData1, outString2 
			local polarity = ""
			local hstText1, hstCurDataText1 = "",""
			local hstText2, hstCurDataText2 = "",""
			--Haste Display
			if LFLT.enabledHaste.cast.enabled then
				hstText1		= string.format(statFormat, "Haste[C]")
				hstCurDataText1 = string.format(dataFormat, statWeightAverages.hst_hpc)
			end
			if LFLT.enabledHaste.casttime.enabled then
				hstText2 		= string.format(statFormat, "Haste[T]")
				hstCurDataText2 = string.format(dataFormat, 
								statWeightAverages.hst_hpc * (1-LFLT.hasteCompositeRatio)
								+ statWeightAverages.hst_hpt * LFLT.hasteCompositeRatio)
			end

			outString1 = string.format("%12s: " .. statFormat .. "%s" ..  "%s" .. statFormat .. statFormat,
						"Intellect", "Crit", hstText1, hstText2, "Mastery", "Versatility")
			outData1 = string.format("%-5." .. tostring(LFLT.option.displayPrecision) .. "f" .. dataFormat .. "%s" ..  "%s" ..  dataFormat .. dataFormat,
						statWeightAverages.int,
						statWeightAverages.crt, 
						hstCurDataText1, hstCurDataText2,
						statWeightAverages.mst,
						statWeightAverages.vrs)
			if healPercChangeAverage > 0 then
				polarity = "+"
			end
			outString2 = "Difference\n" .. polarity .. healPercChangeAverage .. "%\nHealing"
			
			_G[LFLT_F.replayResultWeightFrameTextObjLeft.name]:SetText(outString1)
			_G[LFLT_F.replayResultWeightFrameTextObjRight.name]:SetText(outData1)
			_G[LFLT_F.replayResultPercentFrameTextObj.name]:SetText(outString2)
			_G[LFLT_F.replayFrameWeightTextObjCenter.name]:SetText("")
		else
			print("Leaflet: Please Select an Entry.")
			_G[LFLT_F.replayResultWeightFrameTextObjLeft.name]:SetText(LFLT_F.replayResultWeightFrameTextObjLeft.text)
			_G[LFLT_F.replayResultWeightFrameTextObjRight.name]:SetText("")
			_G[LFLT_F.replayResultPercentFrameTextObj.name]:SetText("Please Select an Entry")
			_G[LFLT_F.replayFrameWeightTextObjCenter.name]:SetText("Replay Stat Weights")
			return
		end
		retrieveDisplayDataBackup()
		LFLT_T.manualOverride.updateDisplay = false
		LFLT_T.updateDisplay(2)
	end
end
